
'Test program for MOD020 Sweet Sensor

'Download program and then click PICAXE>Terminal menu 
'to open Serial Terminal (select baud rate 4800)
'Place a sweet under the light sensor and record the light values.
'Try various sweets in various position to get a range of values 

'We recommend the light sensor is supported by a 30mm+12mm spacer (ie 42mm total length)


 ********************************************
 PICAXE-08M input/output pins

symbol LED = 0 	 Colour sensor white LEDs (output 0)
symbol S2 = 1 	 Colour sensor select S2 (output 1)
symbol ser = 2 	 Servo or serial LCD (output 2)
symbol CSI = 3 	 Colour sensor pulse (input 3)
symbol S3 = 4 	 Colour sensor select S3 (output 4)

 ********************************************
 Variables

symbol red_value = w4 		 Colour sensor red content
symbol blue_value = w5 		 Colour sensor blue content
symbol green_value = w6 	 Colour sensor green content
 Remember w4-w6 uses b8-b13!

 ********************************************
 scan and display every second

main:
	gosub colour 		 scan the colour
	sertxd ("Red =", 9, #red_value, 9)
	sertxd ("Green =", 9, #green_value, 9)
	sertxd ("Blue =", 9, #blue_value, CR, LF)


	'Optionally also output to AXE033 Serial LCD
	'serout 2,N2400,(254,128"R=",#red_value, " ")
	'serout 2,N2400,(254,136"G=",#green_value, " ")
	'serout 2,N2400,(254,192"B=",#blue_value, " ")

	pause 1000
	goto main

 ********************************************
 sub to scan colours

colour:
	high LED 		 LED on
	low S2 		 read red into w4
	low S3
	count 3, 50, red_value
	high S3 		 read blue into w5
	count 3, 50, blue_value
	high S2 		 read green into w6
	count 3, 50, green_value
	low LED 		 LED off
	return


