
#picaxe 14m			; set picaxe type

init:	setfreq m8		; double speed
	pause 1000		; allow 500ms to wake-up

main:	
	if pin0 = 1 then do_play		; play switch pushed
	if pin1 = 1 then do_stop		; stop switch pushed
	goto main

do_play:
	pause 10					; short debounce time
	if pin0 = 1 then do_play		; wait until switch released
	serout 6,t9600_8,("vpf 1.mp3",CR)	; send play 1.mp3
	goto main
	
do_stop:
	pause 10					; short debounce time
	if pin0 = 1 then do_stop		; wait until switch released
	serout 6,t9600_8,("vst",CR)		; send stopcommand
	goto main
	
	
	
	pause 20000					; wait 10 seconds
	serout 6,t9600_8,("vst",CR)		; send stop
	pause 20000					; wait 10 seconds
	serout 6,t9600_8,("vpf 2.mp3",CR)	; send play 2.mp3
	pause 20000					; wait 10 seconds
	serout 6,t9600_8,("vst",CR)		; send stop
	pause 20000					; wait 10 seconds
	goto main



	; create a log file called 'log' (for some reason 'log.txt' didn't work)
	sertxd ("<Sent> Open file",CR,LF)
	hserout 0,("opw log",CR)
	gosub	get_response

	sertxd ("<Sent> write to file",CR,LF)
	bintoascii loopcounter,b5,b6,b7 	; convert loopcounter byte to 3 ascii digits
							; and write 8 bytes loop_xyz
	hserout 0,("wrf ",$00,$00,$00,$08,CR,"loop_",b5,b6,b7,CR)
	gosub	get_response
	
	sertxd ("<Sent> Close file",CR,LF)
	hserout 0,("clf log",CR)
	gosub	get_response
	
	inc loopcounter				; increment counter

	goto main
	
	
	; Sub procedure to receive background bytes
get_response:
	pause 1000			; wait a while	
	sertxd ("<Response> ")
	
	point = 0			; reset local pointer
	
	get point,first_byte	; Save the first reply byte
	
	do
	   get point,temp		; get returned byte
	   sertxd (temp)		; transmit it
	   inc point			; increment pointer
	loop while temp <> CR	; if not CR loop
	
	sertxd (LF)			; Add a LF to the received CR
	sertxd (CR,LF)		; Do another blank line

	hserptr = 0			; reset the background receive pointer 
	return


; Other Useful Commands

; Play all tracks				hserout 0,("w3a",CR)
; Stop track				hserout 0,("vst",CR)
; Skip to Next Track			hserout 0,("vsf",CR)
; Skip to Start of current Track	hserout 0,("vsb",CR)
; Skip to Previous Track		hserout 0,("vsb",CR,"vsb",CR)
; Pause					hserout 0,("e") ; note no CR here
; Resume (after pause)			hserout 0,(CR)
; Set Volume				hserout 0,("vwr",$0B,vol_right,vol_left,CR)
;    where $00 = maximum volume,$FE is the minimum

; Suspend disk				hserout 0,("sud",CR)
; Wakeup disk				hserout 0,("wkd",CR)
; Get firmware version			hserout 0,("fwv",CR)


