; This example program shows how to use the serial hardware
; with automatic background serial receives.
; Serial hardware pins (C6 and C7) connected via MAX232 to
; computers serial port. Output 1 connected to an LED.

; In normal use the LED just flashes. When a background serial receive
; occurs the bytes are echoed back out for testing purposes.

symbol last_byte_received = b1
symbol next_byte_to_echo = b2
symbol counter = b3

; set picaxe type
#picaxe 28x1

; open terminal after download
#terminal 9600
; Don't forget to move serial cable to the hardware pins!


	; setup serial hardware 
	; at 9600 with background receive
	hsersetup b9600_4,%01
	
	'loop waiting for a byte
main:
	
	' do something - e.g. flash LED
	toggle 1		
	pause 500
	
	' test hserinflag which is set when a 
	' background receive occurs
	if hserinflag = 1 then byte_echo
	goto main

	' echo back out the received bytes
byte_echo:
	hserinflag = 0	'reset the flag
		
	' the last scratchpad address written to 
	' will be the serialpointer - 1
	last_byte_received = hserptr - 1
	
	' echo out any bytes we have not yet used 
	for counter = next_byte_to_echo to last_byte_received
		ptr = counter 	' set scatchpad pointer to the relevant address
				 	' and then output the data @ that address
		hserout 0,(#ptr,"=",@ptr,cr,lf)
	next counter

	' set the last byte echoed as the current serialpointer value 
	next_byte_to_echo = last_byte_received + 1
	
	'loop
	goto main

