
' Hyperthermia Alarm Demo Program
' Every 2.3 seconds the temperature is measured.
' If the switch is pushed the LEDS are lit to show the temperature.
' If the temp is below the minimum value, an alarm is sounded.
' The alarm can be reset by pushing the switch.

' Input0	- variable resistor (not used)
' Input2 	- push switch
' Input6 	- temp sensor
' Output0-4 	- LEDs
' Output 7 	- piezo sounder

symbol low_temp = 15				' Define lowest temperature

main:
	let pins = %00000000			' all LEDs off
	sleep 1					' sleep approx 2.3 seconds
	readtemp 6,b1				' read temperature
	'debug b1				' display on computer (testing)
	if input2 = 1 then do_LEDs		' if switch pushed show LEDs
	if b1 < low_temp then sound_alarm	' if below value sound alarm
	goto main				' loop

sound_alarm:
	let pins = %00011111			' all LEDs on
	sound 7,(50,100)			' beep
	if input2 = 1 then stop_alarm		' test switch
	let pins = %00000000			' all LEDs off
	sound 7,(100,100)			' beep
	if input2 = 1 then stop_alarm		' test switch
	goto sound_alarm			' loop

stop_alarm:
	let pins = %00000000			' all LEDs off
	pause 10000				' wait 10 seconds
	goto main				' loop

do_LEDs:					' test light value
	if b1 < 10 then light4	
	if b1 < 15 then light3
	if b1 < 20 then light2
	if b1 < 25 then light1
	goto light0

light4:	high 4					' light LEDs
light3:	high 3
light2:	high 2
light1:	high 1
light0:	high 0
	pause 3000				' wait 3 seconds
	goto main				' loop


