#picaxe 20x2
#no_table

' PICAXE-20X2 sample program for Lego NXT Sensors

' Hitechnic NXT Color Sensor V2 (part MS1038)
' (Note this does not work with Lego NXT Light Sensor or Lego NXT RGB Sensor!)


symbol color_number = b0	'adjusted colour 0 to 17
symbol red_value = b1		
symbol green_value = b2
symbol blue_value = b3
symbol white_value = b4
symbol color_index = b5		'bitwise colour xxRRGGBB

' Wires on NXT jack plug.
' Wire colours may vary. Pin 1 is always end nearest latch.
' 1 White	No connect
' 2 Black	0V
' 3 Red	0V
' 4 Green	V+ (4.5V or 5V)
' 5 Yellow	SCL
' 6 Blue	SDA
' Do not use i2c pullup resistor - already provided within sensor.


init:

	'Slave address is $02
	hi2csetup i2cmaster, $02, i2cslow, i2cbyte


' Configure sensor if required.
' All saved in EEPROM within sensor. Therefore only use once if required.

;	hi2cout $41, ($00)	' set to normal measurement mode (white LED flashed)
;	hi2cout $41, ($01)	' set to passive mode (white LED not flashed, raw data only)
;	hi2cout $41, ($03)	' set to raw mode (LED is used, raw data only in bytes $42-49)
	
;	hi2cout $41, ($42)	' Do Black level calibration
;	hi2cout $41, ($43)	' Do White balance calibration
	
;	hi2cout $41, ($4E)	' set to Near mode (do white/black calibration after changing)
;	hi2cout $41, ($48)	' set to Far mode (do white/black calibration after changing)
	
;	hi2cout $41, ($4C)	' set to LED low power
;	hi2cout $41, ($48)	' set to LED high power
	
;	hi2cout $41, ($35)	' set to 50Hz mode (UK, Europe, Australia)
;	hi2cout $41, ($36)	' set to 60Hz mode (USA)
	
	pause 1000			' do a delay

main:
	; read values
	hi2cin $42,(color_number, red_value, green_value, blue_value, white_value, color_index)	
	; debug display
	debug
	; wait 1 second then loop
	pause 1000
	goto main


