#picaxe 20x2
#no_table
#terminal 9600

' PICAXE-20X2 sample program for Lego NXT Sensors
' Lego NXT Temperature Sensor version (part 9749)

symbol temperature_lowbyte = b0	
symbol temperature_highbyte = b1		
symbol temperature_word = w0		; word is made up of b1 and b0

' Wires on NXT jack plug.
' Wire colours may vary. Pin 1 is always end nearest latch.
' 1 White	No connect
' 2 Black	0V
' 3 Red	0V
' 4 Green	V+ (4.5V or 5V)
' 5 Yellow	SCL
' 6 Blue	SDA
' Do not use i2c pullup resistor - already provided within sensor.

' See the Texas TMP275 datasheet for technical details about the sensor

init:
	'Slave address is $98
	hi2csetup i2cmaster, $98, i2cslow, i2cbyte

	'TMP275 only has 0.5 degree accuracy anyway, so use fast 9 bit mode.
	hi2cout $01,(%00000000)		; configure sensor to  9 bit
	'hi2cout $01,(%00100000)	; configure sensor to 10 bit
	'hi2cout $01,(%01000000)	; configure sensor to 11 bit
	'hi2cout $01,(%01100000)	; configure sensor to 12 bit

main:
	; read temp high byte first
	hi2cin $00,(temperature_highbyte,temperature_lowbyte)	
		
	; in 9 bit mode whole degrees are in highbyte
	; bit7 of lowbyte gives us .5 or .0
	; bit6-0 of low byte not used
	; bit7 of high byte (which is bit15) indicates negative number 
	
	if bit15 = 0 then 'positive temperatue
	
		sertxd ("Temperature = +")
		sertxd (#temperature_highbyte)
		if bit7 = 1 then
			sertxd (".5",cr,lf)
		else
			sertxd (".0",cr,lf)
		end if
	
	else ' negative temperature
	
		' reverse the twos complement of high byte
		dec temperature_highbyte
		temperature_highbyte = NOT temperature_highbyte
		
		sertxd ("Temperature = -")
		sertxd (#temperature_highbyte)

		if bit7 = 1 then
			sertxd (".0",cr,lf)
		else
			sertxd (".5",cr,lf)
		end if
	end if
	
	; wait 1 second then loop
	pause 1000
	goto main


